variables:
  VERSION: "0.3.3"

default:
  image: registry.git.rwth-aachen.de/fair-ds/ap-4-2-demonstrator/ap-4.2-data-validation-and-quality-assurance-demonstrator/main:${VERSION}
  tags:
    - docker

stages:
  - check_schema
  - validate
  - describe
  - pages

.stage_template:
  before_script:
    - mkdir -p "out"
  artifacts:
    paths:
      - "./out"
      - "./schemas"
      - "./public"
      - "state.pickle"
    expire_in: 1 day
    when: always
    exclude:
      - out/xml_report.xml
    reports:
      junit: out/xml_report.xml
  rules:
    - if: $CI_PIPELINE_SOURCE == "web"
  
check_schema:
  extends: .stage_template
  stage:
    check_schema
  script:
    - pip freeze
    - python -m fair_ds_ap42.infer_schemas
      
validate:
  extends: .stage_template
  stage:
    validate
  script:
    - python -m fair_ds_ap42.validate
      
describe:
  extends: .stage_template
  stage:
    describe
  script:
    - python -m fair_ds_ap42.describe_file

pages:
  extends: .stage_template
  stage:
    pages
  script:
    - python -m fair_ds_ap42.make_pages
    - mv -i out/pages public